Index: contrib/crossrpms/rtems4.11/arm/Makefile.am
===================================================================
--- contrib/crossrpms/rtems4.11/arm/Makefile.am	(revision b3036fbb0cd9e089d6582988047dcb27f5bb02c3)
+++ contrib/crossrpms/rtems4.11/arm/Makefile.am	(revision 455acb534bd846374194f0b9092a544e0fefbb29)
@@ -14,5 +14,5 @@
 GCC_VERS = 4.5.0
 GCC_PKGVERS = $(GCC_VERS)
-GCC_RPMREL = 13
+GCC_RPMREL = 14
 
 NEWLIB_VERS = 1.18.0
Index: contrib/crossrpms/rtems4.11/avr/Makefile.am
===================================================================
--- contrib/crossrpms/rtems4.11/avr/Makefile.am	(revision b3036fbb0cd9e089d6582988047dcb27f5bb02c3)
+++ contrib/crossrpms/rtems4.11/avr/Makefile.am	(revision 455acb534bd846374194f0b9092a544e0fefbb29)
@@ -14,5 +14,5 @@
 GCC_VERS = 4.5.0
 GCC_PKGVERS = $(GCC_VERS)
-GCC_RPMREL = 13
+GCC_RPMREL = 14
 NEWLIB_VERS = 1.18.0
 NEWLIB_PKGVERS = $(NEWLIB_VERS)
Index: contrib/crossrpms/rtems4.11/bfin/Makefile.am
===================================================================
--- contrib/crossrpms/rtems4.11/bfin/Makefile.am	(revision b3036fbb0cd9e089d6582988047dcb27f5bb02c3)
+++ contrib/crossrpms/rtems4.11/bfin/Makefile.am	(revision 455acb534bd846374194f0b9092a544e0fefbb29)
@@ -14,5 +14,5 @@
 GCC_VERS = 4.5.0
 GCC_PKGVERS = $(GCC_VERS)
-GCC_RPMREL = 13
+GCC_RPMREL = 14
 NEWLIB_VERS = 1.18.0
 NEWLIB_PKGVERS = $(NEWLIB_VERS)
Index: contrib/crossrpms/rtems4.11/h8300/Makefile.am
===================================================================
--- contrib/crossrpms/rtems4.11/h8300/Makefile.am	(revision b3036fbb0cd9e089d6582988047dcb27f5bb02c3)
+++ contrib/crossrpms/rtems4.11/h8300/Makefile.am	(revision 455acb534bd846374194f0b9092a544e0fefbb29)
@@ -14,5 +14,5 @@
 GCC_VERS = 4.5.0
 GCC_PKGVERS = $(GCC_VERS)
-GCC_RPMREL = 13
+GCC_RPMREL = 14
 NEWLIB_VERS = 1.18.0
 NEWLIB_PKGVERS = $(NEWLIB_VERS)
Index: contrib/crossrpms/rtems4.11/i386/Makefile.am
===================================================================
--- contrib/crossrpms/rtems4.11/i386/Makefile.am	(revision b3036fbb0cd9e089d6582988047dcb27f5bb02c3)
+++ contrib/crossrpms/rtems4.11/i386/Makefile.am	(revision 455acb534bd846374194f0b9092a544e0fefbb29)
@@ -14,5 +14,5 @@
 GCC_VERS = 4.5.0
 GCC_PKGVERS = $(GCC_VERS)
-GCC_RPMREL = 13
+GCC_RPMREL = 14
 NEWLIB_VERS = 1.18.0
 NEWLIB_PKGVERS = $(NEWLIB_VERS)
Index: contrib/crossrpms/rtems4.11/lm32/Makefile.am
===================================================================
--- contrib/crossrpms/rtems4.11/lm32/Makefile.am	(revision b3036fbb0cd9e089d6582988047dcb27f5bb02c3)
+++ contrib/crossrpms/rtems4.11/lm32/Makefile.am	(revision 455acb534bd846374194f0b9092a544e0fefbb29)
@@ -14,5 +14,5 @@
 GCC_VERS = 4.5.0
 GCC_PKGVERS = $(GCC_VERS)
-GCC_RPMREL = 13
+GCC_RPMREL = 14
 NEWLIB_VERS = 1.18.0
 NEWLIB_PKGVERS = $(NEWLIB_VERS)
Index: contrib/crossrpms/rtems4.11/m32c/Makefile.am
===================================================================
--- contrib/crossrpms/rtems4.11/m32c/Makefile.am	(revision b3036fbb0cd9e089d6582988047dcb27f5bb02c3)
+++ contrib/crossrpms/rtems4.11/m32c/Makefile.am	(revision 455acb534bd846374194f0b9092a544e0fefbb29)
@@ -14,5 +14,5 @@
 GCC_VERS = 4.5.0
 GCC_PKGVERS = $(GCC_VERS)
-GCC_RPMREL = 13
+GCC_RPMREL = 14
 NEWLIB_VERS = 1.18.0
 NEWLIB_PKGVERS = $(NEWLIB_VERS)
Index: contrib/crossrpms/rtems4.11/m32r/Makefile.am
===================================================================
--- contrib/crossrpms/rtems4.11/m32r/Makefile.am	(revision b3036fbb0cd9e089d6582988047dcb27f5bb02c3)
+++ contrib/crossrpms/rtems4.11/m32r/Makefile.am	(revision 455acb534bd846374194f0b9092a544e0fefbb29)
@@ -14,5 +14,5 @@
 GCC_VERS = 4.5.0
 GCC_PKGVERS = $(GCC_VERS)
-GCC_RPMREL = 13
+GCC_RPMREL = 14
 NEWLIB_VERS = 1.18.0
 NEWLIB_PKGVERS = $(NEWLIB_VERS)
Index: contrib/crossrpms/rtems4.11/m68k/Makefile.am
===================================================================
--- contrib/crossrpms/rtems4.11/m68k/Makefile.am	(revision b3036fbb0cd9e089d6582988047dcb27f5bb02c3)
+++ contrib/crossrpms/rtems4.11/m68k/Makefile.am	(revision 455acb534bd846374194f0b9092a544e0fefbb29)
@@ -14,5 +14,5 @@
 GCC_VERS = 4.5.0
 GCC_PKGVERS = $(GCC_VERS)
-GCC_RPMREL = 13
+GCC_RPMREL = 14
 NEWLIB_VERS = 1.18.0
 NEWLIB_PKGVERS = $(NEWLIB_VERS)
Index: contrib/crossrpms/rtems4.11/mips/Makefile.am
===================================================================
--- contrib/crossrpms/rtems4.11/mips/Makefile.am	(revision b3036fbb0cd9e089d6582988047dcb27f5bb02c3)
+++ contrib/crossrpms/rtems4.11/mips/Makefile.am	(revision 455acb534bd846374194f0b9092a544e0fefbb29)
@@ -14,5 +14,5 @@
 GCC_VERS = 4.5.0
 GCC_PKGVERS = $(GCC_VERS)
-GCC_RPMREL = 13
+GCC_RPMREL = 14
 NEWLIB_VERS = 1.18.0
 NEWLIB_PKGVERS = $(NEWLIB_VERS)
Index: contrib/crossrpms/rtems4.11/powerpc/Makefile.am
===================================================================
--- contrib/crossrpms/rtems4.11/powerpc/Makefile.am	(revision b3036fbb0cd9e089d6582988047dcb27f5bb02c3)
+++ contrib/crossrpms/rtems4.11/powerpc/Makefile.am	(revision 455acb534bd846374194f0b9092a544e0fefbb29)
@@ -14,5 +14,5 @@
 GCC_VERS = 4.5.0
 GCC_PKGVERS = $(GCC_VERS)
-GCC_RPMREL = 13
+GCC_RPMREL = 14
 NEWLIB_VERS = 1.18.0
 NEWLIB_PKGVERS = $(NEWLIB_VERS)
Index: contrib/crossrpms/rtems4.11/sh/Makefile.am
===================================================================
--- contrib/crossrpms/rtems4.11/sh/Makefile.am	(revision b3036fbb0cd9e089d6582988047dcb27f5bb02c3)
+++ contrib/crossrpms/rtems4.11/sh/Makefile.am	(revision 455acb534bd846374194f0b9092a544e0fefbb29)
@@ -14,5 +14,5 @@
 GCC_VERS = 4.5.0
 GCC_PKGVERS = $(GCC_VERS)
-GCC_RPMREL = 13
+GCC_RPMREL = 14
 NEWLIB_VERS = 1.18.0
 NEWLIB_PKGVERS = $(NEWLIB_VERS)
Index: contrib/crossrpms/rtems4.11/sparc/Makefile.am
===================================================================
--- contrib/crossrpms/rtems4.11/sparc/Makefile.am	(revision b3036fbb0cd9e089d6582988047dcb27f5bb02c3)
+++ contrib/crossrpms/rtems4.11/sparc/Makefile.am	(revision 455acb534bd846374194f0b9092a544e0fefbb29)
@@ -14,5 +14,5 @@
 GCC_VERS = 4.5.0
 GCC_PKGVERS = $(GCC_VERS)
-GCC_RPMREL = 13
+GCC_RPMREL = 14
 NEWLIB_VERS = 1.18.0
 NEWLIB_PKGVERS = $(NEWLIB_VERS)
Index: contrib/crossrpms/rtems4.11/sparc64/Makefile.am
===================================================================
--- contrib/crossrpms/rtems4.11/sparc64/Makefile.am	(revision b3036fbb0cd9e089d6582988047dcb27f5bb02c3)
+++ contrib/crossrpms/rtems4.11/sparc64/Makefile.am	(revision 455acb534bd846374194f0b9092a544e0fefbb29)
@@ -14,5 +14,5 @@
 GCC_VERS = 4.5.0
 GCC_PKGVERS = $(GCC_VERS)
-GCC_RPMREL = 13
+GCC_RPMREL = 14
 NEWLIB_VERS = 1.18.0
 NEWLIB_PKGVERS = $(NEWLIB_VERS)