Index: testsuites/psxtests/Makefile.am
===================================================================
--- testsuites/psxtests/Makefile.am	(revision a1eb0a5793aa9173a7c681943ace88f6eed0aecc)
+++ testsuites/psxtests/Makefile.am	(revision 484ef98c873c8803b3d10f1bdc4ffed3af9d0ae3)
@@ -1071,4 +1071,6 @@
 	psxhdrs/unistd/usleep.c psxhdrs/sys/mman/mlockall.c \
         psxhdrs/utime/utime.c \
+        psxhdrs/wordexp/wordexp.c \
+        psxhdrs/wordexp/wordfree.c \
 	psxhdrs/sys/mman/mlock.c psxhdrs/sys/mman/mmap.c \
 	psxhdrs/sys/mman/mprotect.c psxhdrs/sys/mman/msync.c \
Index: testsuites/psxtests/psxhdrs/wordexp/wordexp.c
===================================================================
--- testsuites/psxtests/psxhdrs/wordexp/wordexp.c	(revision 484ef98c873c8803b3d10f1bdc4ffed3af9d0ae3)
+++ testsuites/psxtests/psxhdrs/wordexp/wordexp.c	(revision 484ef98c873c8803b3d10f1bdc4ffed3af9d0ae3)
@@ -0,0 +1,49 @@
+/**
+ *  @file
+ *  @brief wordexp() API Conformance Test
+ */
+
+/*
+ * SPDX-License-Identifier: BSD-2-Clause
+ *
+ * Copyright (C) 2018 Pritish Jain
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
+ * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
+ * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
+ * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
+ * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
+ * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
+ * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
+ * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
+ * POSSIBILITY OF SUCH DAMAGE.
+ */
+
+#ifdef HAVE_CONFIG_H
+#include "config.h"
+#endif
+
+#include <wordexp.h>
+
+int test( void );
+
+int test( void )
+{
+  int result;
+  wordexp_t p;
+
+  result = wordexp("[a-c]*.c",&p,0);
+
+  return (result != 0);
+}
Index: testsuites/psxtests/psxhdrs/wordexp/wordfree.c
===================================================================
--- testsuites/psxtests/psxhdrs/wordexp/wordfree.c	(revision 484ef98c873c8803b3d10f1bdc4ffed3af9d0ae3)
+++ testsuites/psxtests/psxhdrs/wordexp/wordfree.c	(revision 484ef98c873c8803b3d10f1bdc4ffed3af9d0ae3)
@@ -0,0 +1,50 @@
+/**
+ *  @file
+ *  @brief wordfree() API Conformance Test
+ */
+
+/*
+ * SPDX-License-Identifier: BSD-2-Clause
+ *
+ * Copyright (C) 2018 Pritish Jain
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
+ * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
+ * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
+ * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
+ * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
+ * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
+ * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
+ * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
+ * POSSIBILITY OF SUCH DAMAGE.
+ */
+
+#ifdef HAVE_CONFIG_H
+#include "config.h"
+#endif
+
+#include <wordexp.h>
+
+int test( void );
+
+int test( void )
+{
+  wordexp_t p;
+
+  wordexp("[a-c]*.c",&p,0);
+
+  wordfree(&p);
+
+  return (0);
+}