Index: doc/ada_user/stamp-vti
===================================================================
--- doc/ada_user/stamp-vti	(revision 485b1526f8a33c9d1e1b5e094211301a3f397df5)
+++ doc/ada_user/stamp-vti	(revision 485b1526f8a33c9d1e1b5e094211301a3f397df5)
@@ -0,0 +1,4 @@
+@set UPDATED 11 June 2010
+@set UPDATED-MONTH June 2010
+@set EDITION 4.10.99.0
+@set VERSION 4.10.99.0
Index: doc/ada_user/version.texi
===================================================================
--- doc/ada_user/version.texi	(revision 485b1526f8a33c9d1e1b5e094211301a3f397df5)
+++ doc/ada_user/version.texi	(revision 485b1526f8a33c9d1e1b5e094211301a3f397df5)
@@ -0,0 +1,4 @@
+@set UPDATED 11 June 2010
+@set UPDATED-MONTH June 2010
+@set EDITION 4.10.99.0
+@set VERSION 4.10.99.0
Index: doc/bsp_howto/stamp-vti
===================================================================
--- doc/bsp_howto/stamp-vti	(revision 485b1526f8a33c9d1e1b5e094211301a3f397df5)
+++ doc/bsp_howto/stamp-vti	(revision 485b1526f8a33c9d1e1b5e094211301a3f397df5)
@@ -0,0 +1,4 @@
+@set UPDATED 4 August 2009
+@set UPDATED-MONTH August 2009
+@set EDITION 4.10.99.0
+@set VERSION 4.10.99.0
Index: doc/bsp_howto/version.texi
===================================================================
--- doc/bsp_howto/version.texi	(revision 485b1526f8a33c9d1e1b5e094211301a3f397df5)
+++ doc/bsp_howto/version.texi	(revision 485b1526f8a33c9d1e1b5e094211301a3f397df5)
@@ -0,0 +1,4 @@
+@set UPDATED 4 August 2009
+@set UPDATED-MONTH August 2009
+@set EDITION 4.10.99.0
+@set VERSION 4.10.99.0
Index: doc/cpu_supplement/stamp-vti
===================================================================
--- doc/cpu_supplement/stamp-vti	(revision 485b1526f8a33c9d1e1b5e094211301a3f397df5)
+++ doc/cpu_supplement/stamp-vti	(revision 485b1526f8a33c9d1e1b5e094211301a3f397df5)
@@ -0,0 +1,4 @@
+@set UPDATED 11 June 2010
+@set UPDATED-MONTH June 2010
+@set EDITION 4.10.99.0
+@set VERSION 4.10.99.0
Index: doc/cpu_supplement/version.texi
===================================================================
--- doc/cpu_supplement/version.texi	(revision 485b1526f8a33c9d1e1b5e094211301a3f397df5)
+++ doc/cpu_supplement/version.texi	(revision 485b1526f8a33c9d1e1b5e094211301a3f397df5)
@@ -0,0 +1,4 @@
+@set UPDATED 11 June 2010
+@set UPDATED-MONTH June 2010
+@set EDITION 4.10.99.0
+@set VERSION 4.10.99.0
Index: doc/develenv/stamp-vti
===================================================================
--- doc/develenv/stamp-vti	(revision 485b1526f8a33c9d1e1b5e094211301a3f397df5)
+++ doc/develenv/stamp-vti	(revision 485b1526f8a33c9d1e1b5e094211301a3f397df5)
@@ -0,0 +1,4 @@
+@set UPDATED 6 December 2007
+@set UPDATED-MONTH December 2007
+@set EDITION 4.10.99.0
+@set VERSION 4.10.99.0
Index: doc/develenv/version.texi
===================================================================
--- doc/develenv/version.texi	(revision 485b1526f8a33c9d1e1b5e094211301a3f397df5)
+++ doc/develenv/version.texi	(revision 485b1526f8a33c9d1e1b5e094211301a3f397df5)
@@ -0,0 +1,4 @@
+@set UPDATED 6 December 2007
+@set UPDATED-MONTH December 2007
+@set EDITION 4.10.99.0
+@set VERSION 4.10.99.0
Index: doc/filesystem/stamp-vti
===================================================================
--- doc/filesystem/stamp-vti	(revision 485b1526f8a33c9d1e1b5e094211301a3f397df5)
+++ doc/filesystem/stamp-vti	(revision 485b1526f8a33c9d1e1b5e094211301a3f397df5)
@@ -0,0 +1,4 @@
+@set UPDATED 27 June 2007
+@set UPDATED-MONTH June 2007
+@set EDITION 4.10.99.0
+@set VERSION 4.10.99.0
Index: doc/filesystem/version.texi
===================================================================
--- doc/filesystem/version.texi	(revision 485b1526f8a33c9d1e1b5e094211301a3f397df5)
+++ doc/filesystem/version.texi	(revision 485b1526f8a33c9d1e1b5e094211301a3f397df5)
@@ -0,0 +1,4 @@
+@set UPDATED 27 June 2007
+@set UPDATED-MONTH June 2007
+@set EDITION 4.10.99.0
+@set VERSION 4.10.99.0
Index: doc/itron3.0/stamp-vti
===================================================================
--- doc/itron3.0/stamp-vti	(revision 485b1526f8a33c9d1e1b5e094211301a3f397df5)
+++ doc/itron3.0/stamp-vti	(revision 485b1526f8a33c9d1e1b5e094211301a3f397df5)
@@ -0,0 +1,4 @@
+@set UPDATED 27 June 2007
+@set UPDATED-MONTH June 2007
+@set EDITION 4.10.99.0
+@set VERSION 4.10.99.0
Index: doc/itron3.0/version.texi
===================================================================
--- doc/itron3.0/version.texi	(revision 485b1526f8a33c9d1e1b5e094211301a3f397df5)
+++ doc/itron3.0/version.texi	(revision 485b1526f8a33c9d1e1b5e094211301a3f397df5)
@@ -0,0 +1,4 @@
+@set UPDATED 27 June 2007
+@set UPDATED-MONTH June 2007
+@set EDITION 4.10.99.0
+@set VERSION 4.10.99.0
Index: doc/networking/stamp-vti
===================================================================
--- doc/networking/stamp-vti	(revision 485b1526f8a33c9d1e1b5e094211301a3f397df5)
+++ doc/networking/stamp-vti	(revision 485b1526f8a33c9d1e1b5e094211301a3f397df5)
@@ -0,0 +1,4 @@
+@set UPDATED 27 June 2007
+@set UPDATED-MONTH June 2007
+@set EDITION 4.10.99.0
+@set VERSION 4.10.99.0
Index: doc/networking/version.texi
===================================================================
--- doc/networking/version.texi	(revision 485b1526f8a33c9d1e1b5e094211301a3f397df5)
+++ doc/networking/version.texi	(revision 485b1526f8a33c9d1e1b5e094211301a3f397df5)
@@ -0,0 +1,4 @@
+@set UPDATED 27 June 2007
+@set UPDATED-MONTH June 2007
+@set EDITION 4.10.99.0
+@set VERSION 4.10.99.0
Index: doc/new_chapters/stamp-vti
===================================================================
--- doc/new_chapters/stamp-vti	(revision 485b1526f8a33c9d1e1b5e094211301a3f397df5)
+++ doc/new_chapters/stamp-vti	(revision 485b1526f8a33c9d1e1b5e094211301a3f397df5)
@@ -0,0 +1,4 @@
+@set UPDATED 27 June 2007
+@set UPDATED-MONTH June 2007
+@set EDITION 4.10.99.0
+@set VERSION 4.10.99.0
Index: doc/new_chapters/version.texi
===================================================================
--- doc/new_chapters/version.texi	(revision 485b1526f8a33c9d1e1b5e094211301a3f397df5)
+++ doc/new_chapters/version.texi	(revision 485b1526f8a33c9d1e1b5e094211301a3f397df5)
@@ -0,0 +1,4 @@
+@set UPDATED 27 June 2007
+@set UPDATED-MONTH June 2007
+@set EDITION 4.10.99.0
+@set VERSION 4.10.99.0
Index: doc/porting/stamp-vti
===================================================================
--- doc/porting/stamp-vti	(revision 485b1526f8a33c9d1e1b5e094211301a3f397df5)
+++ doc/porting/stamp-vti	(revision 485b1526f8a33c9d1e1b5e094211301a3f397df5)
@@ -0,0 +1,4 @@
+@set UPDATED 27 June 2007
+@set UPDATED-MONTH June 2007
+@set EDITION 4.10.99.0
+@set VERSION 4.10.99.0
Index: doc/porting/version.texi
===================================================================
--- doc/porting/version.texi	(revision 485b1526f8a33c9d1e1b5e094211301a3f397df5)
+++ doc/porting/version.texi	(revision 485b1526f8a33c9d1e1b5e094211301a3f397df5)
@@ -0,0 +1,4 @@
+@set UPDATED 27 June 2007
+@set UPDATED-MONTH June 2007
+@set EDITION 4.10.99.0
+@set VERSION 4.10.99.0
Index: doc/posix1003.1/stamp-vti
===================================================================
--- doc/posix1003.1/stamp-vti	(revision 485b1526f8a33c9d1e1b5e094211301a3f397df5)
+++ doc/posix1003.1/stamp-vti	(revision 485b1526f8a33c9d1e1b5e094211301a3f397df5)
@@ -0,0 +1,4 @@
+@set UPDATED 27 June 2007
+@set UPDATED-MONTH June 2007
+@set EDITION 4.10.99.0
+@set VERSION 4.10.99.0
Index: doc/posix1003.1/version.texi
===================================================================
--- doc/posix1003.1/version.texi	(revision 485b1526f8a33c9d1e1b5e094211301a3f397df5)
+++ doc/posix1003.1/version.texi	(revision 485b1526f8a33c9d1e1b5e094211301a3f397df5)
@@ -0,0 +1,4 @@
+@set UPDATED 27 June 2007
+@set UPDATED-MONTH June 2007
+@set EDITION 4.10.99.0
+@set VERSION 4.10.99.0
Index: doc/posix_users/stamp-vti
===================================================================
--- doc/posix_users/stamp-vti	(revision 485b1526f8a33c9d1e1b5e094211301a3f397df5)
+++ doc/posix_users/stamp-vti	(revision 485b1526f8a33c9d1e1b5e094211301a3f397df5)
@@ -0,0 +1,4 @@
+@set UPDATED 27 June 2007
+@set UPDATED-MONTH June 2007
+@set EDITION 4.10.99.0
+@set VERSION 4.10.99.0
Index: doc/posix_users/version.texi
===================================================================
--- doc/posix_users/version.texi	(revision 485b1526f8a33c9d1e1b5e094211301a3f397df5)
+++ doc/posix_users/version.texi	(revision 485b1526f8a33c9d1e1b5e094211301a3f397df5)
@@ -0,0 +1,4 @@
+@set UPDATED 27 June 2007
+@set UPDATED-MONTH June 2007
+@set EDITION 4.10.99.0
+@set VERSION 4.10.99.0
Index: doc/relnotes/stamp-vti
===================================================================
--- doc/relnotes/stamp-vti	(revision 485b1526f8a33c9d1e1b5e094211301a3f397df5)
+++ doc/relnotes/stamp-vti	(revision 485b1526f8a33c9d1e1b5e094211301a3f397df5)
@@ -0,0 +1,4 @@
+@set UPDATED 27 June 2007
+@set UPDATED-MONTH June 2007
+@set EDITION 4.10.99.0
+@set VERSION 4.10.99.0
Index: doc/relnotes/version.texi
===================================================================
--- doc/relnotes/version.texi	(revision 485b1526f8a33c9d1e1b5e094211301a3f397df5)
+++ doc/relnotes/version.texi	(revision 485b1526f8a33c9d1e1b5e094211301a3f397df5)
@@ -0,0 +1,4 @@
+@set UPDATED 27 June 2007
+@set UPDATED-MONTH June 2007
+@set EDITION 4.10.99.0
+@set VERSION 4.10.99.0
Index: doc/shell/stamp-vti
===================================================================
--- doc/shell/stamp-vti	(revision 485b1526f8a33c9d1e1b5e094211301a3f397df5)
+++ doc/shell/stamp-vti	(revision 485b1526f8a33c9d1e1b5e094211301a3f397df5)
@@ -0,0 +1,4 @@
+@set UPDATED 29 February 2008
+@set UPDATED-MONTH February 2008
+@set EDITION 4.10.99.0
+@set VERSION 4.10.99.0
Index: doc/shell/version.texi
===================================================================
--- doc/shell/version.texi	(revision 485b1526f8a33c9d1e1b5e094211301a3f397df5)
+++ doc/shell/version.texi	(revision 485b1526f8a33c9d1e1b5e094211301a3f397df5)
@@ -0,0 +1,4 @@
+@set UPDATED 29 February 2008
+@set UPDATED-MONTH February 2008
+@set EDITION 4.10.99.0
+@set VERSION 4.10.99.0
Index: doc/started/stamp-vti
===================================================================
--- doc/started/stamp-vti	(revision 485b1526f8a33c9d1e1b5e094211301a3f397df5)
+++ doc/started/stamp-vti	(revision 485b1526f8a33c9d1e1b5e094211301a3f397df5)
@@ -0,0 +1,4 @@
+@set UPDATED 27 June 2007
+@set UPDATED-MONTH June 2007
+@set EDITION 4.10.99.0
+@set VERSION 4.10.99.0
Index: doc/started/version.texi
===================================================================
--- doc/started/version.texi	(revision 485b1526f8a33c9d1e1b5e094211301a3f397df5)
+++ doc/started/version.texi	(revision 485b1526f8a33c9d1e1b5e094211301a3f397df5)
@@ -0,0 +1,4 @@
+@set UPDATED 27 June 2007
+@set UPDATED-MONTH June 2007
+@set EDITION 4.10.99.0
+@set VERSION 4.10.99.0
Index: doc/started_ada/stamp-vti
===================================================================
--- doc/started_ada/stamp-vti	(revision 485b1526f8a33c9d1e1b5e094211301a3f397df5)
+++ doc/started_ada/stamp-vti	(revision 485b1526f8a33c9d1e1b5e094211301a3f397df5)
@@ -0,0 +1,4 @@
+@set UPDATED 27 June 2007
+@set UPDATED-MONTH June 2007
+@set EDITION 4.10.99.0
+@set VERSION 4.10.99.0
Index: doc/started_ada/version.texi
===================================================================
--- doc/started_ada/version.texi	(revision 485b1526f8a33c9d1e1b5e094211301a3f397df5)
+++ doc/started_ada/version.texi	(revision 485b1526f8a33c9d1e1b5e094211301a3f397df5)
@@ -0,0 +1,4 @@
+@set UPDATED 27 June 2007
+@set UPDATED-MONTH June 2007
+@set EDITION 4.10.99.0
+@set VERSION 4.10.99.0
Index: doc/user/stamp-vti
===================================================================
--- doc/user/stamp-vti	(revision 485b1526f8a33c9d1e1b5e094211301a3f397df5)
+++ doc/user/stamp-vti	(revision 485b1526f8a33c9d1e1b5e094211301a3f397df5)
@@ -0,0 +1,4 @@
+@set UPDATED 11 November 2009
+@set UPDATED-MONTH November 2009
+@set EDITION 4.10.99.0
+@set VERSION 4.10.99.0
Index: doc/user/version.texi
===================================================================
--- doc/user/version.texi	(revision 485b1526f8a33c9d1e1b5e094211301a3f397df5)
+++ doc/user/version.texi	(revision 485b1526f8a33c9d1e1b5e094211301a3f397df5)
@@ -0,0 +1,4 @@
+@set UPDATED 11 November 2009
+@set UPDATED-MONTH November 2009
+@set EDITION 4.10.99.0
+@set VERSION 4.10.99.0